import heapq

class BFS:

    def __init__(self, game):
        self.game = game
        self.fringe = []
        self.addSuccessorsToFringe(game.start, [], 0)
        self.seen = set()

    def nextState(self):
        '''
        Returns the next state to consider, along with its path and total cost. Adds all of its successors to the fringe.
        '''
        ## Pick next state off the fringe.
        (state, path, cost) = self.fringe.pop(0)
        while state in self.seen and len(self.fringe) > 0:
            (state, path, cost) = self.fringe.pop(0)

        self.seen.add(state)

        ## Add its successors to the fringe.
        ## TODO -- add this!

        return state, path, cost


    def addSuccessorsToFringe(self, state, path, pathCost):
        for successor,cost,dist in self.game.successors(state):
            self.fringe.append((
                successor,
                path + [state], 
                pathCost + cost
            ))

